// Copyright 1997 by Richard Mansfield; see the file COPYING.

import expr.*;

public class XYTFunction {
	private Expr e;
	private Variable xvar = Variable.make("x");
	private Variable yvar = Variable.make("y");
	private Variable tvar = Variable.make("t");

	XYTFunction(String s) {
		try { e = Parser.parse (s); }
		catch (Syntax_error error) {
			System.err.println ("Syntax error: " + error);
			return;
		}
	}
	
	double value(double x, double y, double t) {
		xvar.set_value(x);
		yvar.set_value(y);
		tvar.set_value(t);
		return e.value();
	}
}
