
// Copyright 1997 by Richard Mansfield; see the file COPYING.

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;

public class myCanvas extends Canvas
		implements MouseListener, MouseMotionListener {
	Image pad;
	Graphics gpad;
	XYTFunction f, g;
	Rtwo initf, initb;
	private final int mesh = 15;
	boolean	plotslopes = true,
		goforth = true,
		plot_solutions = true;
	Color orbitcolor = Color.black;
	int history = 0, kleur[] = new int[200];
        RealFrame realLimits = new RealFrame();
	Rtwo movie[][] = new Rtwo[200][realLimits.stepcount];
	Rtwo inits[][] = new Rtwo[200][2];
	double timef=0, timeb=0;
	
myCanvas() {
	setBackground(newphase.back);
	this.addMouseMotionListener(this);
	this.addMouseListener(this);
}

public void mouseClicked(MouseEvent e) {}
public void mouseEntered(MouseEvent e) {}
public void mouseExited(MouseEvent e) {}
public void mousePressed(MouseEvent e) {
	int x = e.getX();
	int y = e.getY();
     	timef=0;
     	timeb=0;
     	newphase.d.clear();
	plot_solutions = true;
     	if (newphase.c.pad != null){
		if (goforth) {
	     		initf = realLimits.toRtwo(x, y);
			forwardLoop();
			record();
			initb = realLimits.toRtwo(x, y);
		} else {
	     		initb = realLimits.toRtwo(x, y);
			backwardLoop();
			record();
			initf = realLimits.toRtwo(x, y);
		}
    	}	
     	repaint();
     	newphase.d.repaint();

}
public void mouseReleased(MouseEvent e) {}
public void mouseDragged(MouseEvent e) {}
public void mouseMoved(MouseEvent e) {
	int x = e.getX();
	int y = e.getY();
	Graphics hg = getGraphics();
        if (hg == null) return;
     	Rtwo point = realLimits.toRtwo(x, y);
     	hg.setColor(newphase.back);
     	hg.fillRect(0,0,200,25);
     	hg.setColor(orbitcolor);
        hg.drawString("x= "+point.xcord, 2, 12);
        hg.drawString("y= "+point.ycord, 2, 24);
	hg.dispose();

}

public void setBounds(int x, int y, int width, int height) {
	super.setBounds(x, y, width, height);
	pad = createImage(width, height);
	gpad = pad.getGraphics();
	realLimits.realSetup(width, height);
	//Draw the little white lines and cordinate axes
	f = new XYTFunction(newphase.text1.getText());
	g = new XYTFunction(newphase.text2.getText());
	replay();
}

public void clear() {
	initf=null;initb=null;
	history=0;
	gpad.setColor(newphase.back);
	gpad.fillRect(0,0, getSize().width-1, getSize().height-1);
	//f(x,y) is x', g(x,y) is y'.
	f = new XYTFunction(newphase.text1.getText());
	g = new XYTFunction(newphase.text2.getText());
	//Draw the little white lines and cordinate axes
	if (plotslopes) drawSlopes(newphase.fore);
	newphase.d.clear();
	repaint();
	}

public void setframe(double xmin, double xmax, double ymin, double ymax,
		double tmin, double tmax) {
	realLimits.setframe(xmin, xmax, ymin, ymax);
	newphase.xminField.setText(Double.toString(xmin));
	newphase.xmaxField.setText(Double.toString(xmax));
	newphase.yminField.setText(Double.toString(ymin));
	newphase.ymaxField.setText(Double.toString(ymax));

}

public void drawSlopes(Color col) {
	int	xstep = getSize().width/mesh,
		ystep = getSize().height/mesh;

	gpad.setColor(col);

	Point p = realLimits.fromRtwo(0, 0);
	gpad.drawLine(p.x, 0, p.x, getSize().height-1);
	gpad.drawLine(0, p.y, getSize().width-1, p.y);

	Rtwo p1 = realLimits.toRtwo(xstep, ystep);
	Rtwo p2 = realLimits.toRtwo(2*xstep, 2*ystep);
	double a = p2.xcord-p1.xcord,
	       b = p2.ycord-p1.ycord;
	double N = Math.sqrt(a*a+b*b);
	for (int i = xstep; i < getSize().width; i = i + xstep)
	for (int j = ystep; j < getSize().height; j = j + ystep) {
		Rtwo point = realLimits.toRtwo(i, j);
		double L = f.value(point.xcord, point.ycord,0);
		double M = g.value(point.xcord, point.ycord,0);
		double Mod = 4*Math.sqrt(L*L+M*M);
		Point q1 = realLimits.fromRtwo(point.xcord+L*N/Mod,
			point.ycord+M*N/Mod);
		Point q2 = realLimits.fromRtwo(point.xcord,
			point.ycord);
		gpad.drawLine(q2.x, q2.y, q1.x, q1.y);
		gpad.fillOval(q2.x, q2.y, 4, 4);
		}	//remember the pixel cordinates have y upside down!
	}

public void forwardLoop(){
	Point p,q;
	if (initf==null) return;
	q = realLimits.fromRtwo(initf.xcord, initf.ycord);
     	newphase.stepper.initialize(initf.xcord, initf.ycord, timef,
		realLimits.stepsize);
	newphase.d.cursor(initf.xcord, initf.ycord, timef);
	movie[history][0] = initf;
	gpad.setColor(orbitcolor);
     	for (int i = 1; i < realLimits.stepcount; i = i+1) {
		if (Math.abs(q.x) >= 2*this.getSize().width ||
		Math.abs(q.y) >= 2*this.getSize().height)
			{movie[history][i] = null; break;}
	     	Rthree quark = newphase.stepper.next();
		initf = new Rtwo(quark.xcord, quark.ycord);
	     	timef = quark.tcord;
		p = realLimits.fromRtwo(initf.xcord, initf.ycord);
	     	gpad.drawLine(q.x, q.y, p.x, p.y);
	     	if (plot_solutions)
			newphase.d.next(initf.xcord, initf.ycord, timef);
		movie[history][i] = initf;
	     	q=p;
	     	}
	}

public void backwardLoop(){
	Point p,q;

	if (initb==null) return;
	q = realLimits.fromRtwo(initb.xcord, initb.ycord);
     	newphase.stepper.initialize(initb.xcord, initb.ycord, timeb,
		-realLimits.stepsize);
	newphase.d.cursor(initb.xcord, initb.ycord, timeb);
	movie[history][0] = initb;
	gpad.setColor(orbitcolor);
     	for (int i = 1; i < realLimits.stepcount; i = i+1) {
		if (Math.abs(q.x) >= 2*this.getSize().width ||
		Math.abs(q.y) >= 2*this.getSize().height)
			{movie[history][i] = null; break;}
	     	Rthree quark = newphase.stepper.next();
		initb = new Rtwo(quark.xcord, quark.ycord);
	     	timeb = quark.tcord;
		p = realLimits.fromRtwo(initb.xcord, initb.ycord);
	     	gpad.drawLine(q.x, q.y, p.x, p.y);
	     	if (plot_solutions)
			newphase.d.next(initb.xcord, initb.ycord, timeb);
		movie[history][i] = initb;
	     	q=p;
	     	}
	}

public void record() {
	kleur[history] = orbitcolor.getRGB();
	inits[history][0] = initf;
	inits[history][1] = initb;
	history = history + 1;
	}

public void replay() {
	Point p,q;

	gpad.setColor(newphase.back);
	gpad.fillRect(0,0,getSize().width-1, getSize().height-1);
	if (plotslopes) drawSlopes(newphase.fore);
	for (int t = 0; t<history; t++) {
		gpad.setColor(new Color(kleur[t]));
		for (int s = 1; s<realLimits.stepcount; s++) {
			p = realLimits.fromRtwo(
				movie[t][s-1].xcord,movie[t][s-1].ycord);
			if (movie[t][s]==null) break;
			q = realLimits.fromRtwo(
				movie[t][s].xcord,movie[t][s].ycord);
			gpad.drawLine(p.x,p.y,q.x,q.y);
			}
		}
	repaint();
	}

public void undo() {
	newphase.d.clear();
	plot_solutions = false;
	if (history>0) history=history-1;
	replay();
	if (history>0) {
		initf = inits[history-1][0];
		initb = inits[history-1][1];
		}
	else {initf=null; initb=null;}
	}

//Overwrite update to cut out default clearscreen.	
public void update(Graphics g) {
	paint(g);
}

public void paint(Graphics g) {
	if (pad == null){
		pad = createImage(getSize().width, getSize().height);
		// pad is the off-screen buffer.
		gpad = pad.getGraphics();
		realLimits.realSetup(getSize().width, getSize().height);
		clear();
	}
	g.drawImage(pad, 0, 0, null);
     }
public void drawBox(XYTFunction f, 
	double x, double y, double deltax, double deltay, int level) {
	double	x1 = x-deltax,
		x2 = x+deltax,
		y1 = y-deltay,
		y2 = y+deltay,
		a  = f.value(x1,y1,0),
		b  = f.value(x1,y2,0),
		c  = f.value(x2,y1,0),
		d  = f.value(x2,y2,0);
	Point	q1,
		q2;
	
	if (a < 0) {a = -a; b = -b; c = -c; d = -d;}
	if (b>0 && c>0 && d>0) return;
   if (level <= 0) {
	if (b>0 && c>0){
		q1 = realLimits.fromRtwo(x, y2);
		q2 = realLimits.fromRtwo(x2, y);
		gpad.drawLine(q1.x, q1.y, q2.x,q2.y);
		return;
	}
	if (b>0 && d>0){
		q1 = realLimits.fromRtwo(x, y1);
		q2 = realLimits.fromRtwo(x2, y);
		gpad.drawLine(q1.x, q1.y, q2.x,q2.y);
		return;
	}
	if (b>0){
		q1 = realLimits.fromRtwo(x, y2);
		q2 = realLimits.fromRtwo(x, y1);
		gpad.drawLine(q1.x, q1.y, q2.x,q2.y);
		return;
	}
	if (c>0 && d>0){
		q1 = realLimits.fromRtwo(x, y2);
		q2 = realLimits.fromRtwo(x1, y);
		gpad.drawLine(q1.x, q1.y, q2.x,q2.y);
		return;
	}
	if (c>0){
		q1 = realLimits.fromRtwo(x1, y);
		q2 = realLimits.fromRtwo(x2, y);
		gpad.drawLine(q1.x, q1.y, q2.x,q2.y);
		return;
	}
	if (d>0){
		q1 = realLimits.fromRtwo(x1, y);
		q2 = realLimits.fromRtwo(x2, y);
		gpad.drawLine(q1.x, q1.y, q2.x,q2.y);
		q1 = realLimits.fromRtwo(x, y2);
		q2 = realLimits.fromRtwo(x, y1);
		gpad.drawLine(q1.x, q1.y, q2.x,q2.y);
		return;
	}
	q1 = realLimits.fromRtwo(x, y1);
	q2 = realLimits.fromRtwo(x1, y);
	gpad.drawLine(q1.x, q1.y, q2.x,q2.y);
	return;
    }
	deltax = deltax/2;
	deltay = deltay/2;
	double newx = x-deltax;
	double newy = y-deltay;
	drawBox(f, newx, newy, deltax, deltay, level-1);
	newx = x-deltax;
	newy = y+deltay;
	drawBox(f, newx, newy, deltax, deltay, level-1);
	newx = x+deltax;
	newy = y-deltay;
	drawBox(f, newx, newy, deltax, deltay, level-1);
	newx = x+deltax;
	newy = y+deltay;
	drawBox(f, newx, newy, deltax, deltay, level-1);
}

public void drawBoxes(XYTFunction f) {
	int mesh = newphase.mesh;
	Random r = new Random();
	double fudge_factor = (realLimits.range().xcord +
				realLimits.range().ycord)/1000;
	fudge_factor = fudge_factor*r.nextGaussian();
	double deltax = fudge_factor+realLimits.range().xcord/(2*mesh);
	double deltay = fudge_factor+realLimits.range().ycord/(2*mesh);
	Rtwo p = realLimits.toRtwo(0, this.getSize().height-1);
	for (int i = 0; i <= mesh; i = i+1)
	for (int j = 0; j <= mesh; j = j+1) {
		drawBox(f, p.xcord+(2*i+1)*deltax, p.ycord+(2*j+1)*deltay,
			deltax, deltay, newphase.level);
	}

}


}

